local _, Rotacast = ...
Rotacast.Frames = {}
Rotacast.Functions = {}
Rotacast.Data = {}
function Rotacast.Functions.CreateData(Self)
Rotacast.Data.Title, Rotacast.Data.Version = GetAddOnMetadata(Self, "Title"), GetAddOnMetadata(Self, "Version")
if not RotacastPerDB then RotacastPerDB = {}; end
if not RotacastPerDB.Buttons then RotacastPerDB.Buttons = {}; end
if not RotacastPerDB.ScrollBind then RotacastPerDB.ScrollBind = "Off"; end
if not RotacastPerDB.LoadShow then RotacastPerDB.LoadShow = {["Cast"] = true, ["Sequence"] = false, ["Binding"] = false}; end
if not RotacastPerDB.SequenceOptions then RotacastPerDB.SequenceOptions = {["Combat"] = false, ["Enter"] = false, ["Leave"] = false, ["Switch"] = false}; end
if not RotacastPerDB.SequenceOptions.Default then RotacastPerDB.SequenceOptions.Default = false; end
Rotacast.Data.GuideData = "Left click the cast button to cast, right click to reset sequence to the beginning\nAdd spell or macro to sequence by dragging onto the cast button\nReplace a spell or macro by dragging onto the sequence bar\nDrag spells or macros around the sequence bar to reorder them\nLeft click a spell or macro on the sequence bar to set it as the next to be cast\nRight click a spell or macro on the sequence bar to remove it\nLeft click minimap icon to show/hide cast button\nRight click minimap icon to show/hide sequence bar\nMiddle click minimap icon to show/hide options\nSet a hotkey by opening options, then pressing the desired key combination and click \"Set Hotkey\"\nCancel a hotkey by clearing key combination box and click \"Set Hotkey\"\nTurn scroll casting on/off by clicking \"Scroll Cast\"\nUse cast sequence options to set conditions for sequence reset\nUse button on the left of cast sequence title bar for Create /Delete options\nUse Up /Down buttons on the right of cast sequence title bar to scroll through sequences"
end
function Rotacast.Functions.CreateFrames()
Rotacast.Frames.GuideDisplay = CreateFrame("ScrollFrame", "Rotacast.Frames.GuideDisplay", UIParent, "SecureHandlerBaseTemplate, InputScrollFrameTemplate")
tinsert(UISpecialFrames, "Rotacast.Frames.GuideDisplay")
Rotacast.Frames.GuideDisplay:SetFrameStrata("Dialog")
Rotacast.Frames.GuideDisplay:SetBackdrop{bgFile = "Interface\\FrameGeneral\\UI-Background-Marble"}
Rotacast.Frames.GuideDisplay:SetMovable(true)
Rotacast.Frames.GuideDisplay:RegisterForDrag("LeftButton")
Rotacast.Frames.GuideDisplay:SetScript("OnDragStart", Rotacast.Frames.GuideDisplay.StartMoving)
Rotacast.Frames.GuideDisplay:SetScript("OnDragStop", Rotacast.Frames.GuideDisplay.StopMovingOrSizing)
Rotacast.Frames.GuideDisplay:SetSize(570, 218)
Rotacast.Frames.GuideDisplay:SetPoint("Right", -45, 30)
Rotacast.Frames.GuideDisplay.CharCount:Hide()
Rotacast.Frames.GuideDisplay.EditBox:SetSize(568, 190)
Rotacast.Frames.GuideDisplay.EditBox:SetFontObject("ChatFontNormal")
Rotacast.Frames.GuideDisplay.EditBox:SetTextColor(0.90, 0.60, 0, 1)
Rotacast.Frames.GuideDisplay.EditBox:EnableMouse(false)
Rotacast.Frames.GuideDisplay.EditBox:EnableKeyboard(false)
Rotacast.Frames.GuideDisplay.EditBox:Disable(true)
Rotacast.Frames.GuideDisplay.EditBox:SetText(Rotacast.Data.GuideData)
Rotacast.Frames.GuideDisplay.Close = CreateFrame("Button", nil, Rotacast.Frames.GuideDisplay, "UIPanelCloseButton")
Rotacast.Frames.GuideDisplay.Close:SetSize(40, 40)
Rotacast.Frames.GuideDisplay.Close:SetPoint("TopRight", 10, 37)
Rotacast.Frames.Icon = CreateFrame("Button", "Rotacast.Frames.Icon", MinimapCluster, "SecureHandlerClickTemplate")
Rotacast.Frames.Icon:SetAttribute("Rotacast.Data.Title", Rotacast.Data.Title)
Rotacast.Frames.Icon:SetAttribute("Rotacast.Data.Version", Rotacast.Data.Version)
Rotacast.Frames.Icon:SetClampedToScreen(true)
Rotacast.Frames.Icon:SetMovable(true)
Rotacast.Frames.Icon:EnableMouse(true)
Rotacast.Frames.Icon:SetUserPlaced(true)
Rotacast.Frames.Icon:SetSize(32, 32)
Rotacast.Frames.Icon:SetPoint("BottomRight")
Rotacast.Frames.Icon:SetFrameStrata("High")
Rotacast.Frames.Icon:SetHighlightTexture(136477)
local Border = Rotacast.Frames.Icon:CreateTexture(nil, "OVERLAY")
Border:SetSize(53, 53)
Border:SetTexture(136430)
Border:SetPoint("TopLeft")
local Background = Rotacast.Frames.Icon:CreateTexture(nil, "BACKGROUND")
Background:SetSize(20, 20)
Background:SetTexture(136467)
Background:SetPoint("TopLeft", 7, -5)
local Icon = Rotacast.Frames.Icon:CreateTexture(nil, "ARTWORK")
Icon:SetTexture("Interface\\Addons\\Rotacast\\Images\\Icon")
Icon:SetSize(12,12)
Icon:SetPoint("Center", 0, 0)
Rotacast.Frames.Icon:RegisterForDrag("LeftButton")
Rotacast.Frames.Icon:RegisterForClicks("AnyUp")
Rotacast.Frames.Icon:SetScript("OnDragStart", Rotacast.Frames.Icon.StartMoving)
Rotacast.Frames.Icon:SetScript("OnDragStop", Rotacast.Frames.Icon.StopMovingOrSizing)
local function IconMessage(Self)
GameTooltip:SetOwner(Self, "ANCHOR_BOTTOMRIGHT")
GameTooltip:SetText("Rotacast")
local Msg1, Msg2, Msg2
if RotacastPerDB.LoadShow.Cast then Msg1 = "Hide"; else Msg1 = "Show"; end
if RotacastPerDB.LoadShow.Sequence then Msg2 = "Hide"; else Msg2 = "Show"; end
if RotacastPerDB.LoadShow.Binding then Msg3 = "Hide"; else Msg3 = "Show"; end
GameTooltip:AddLine("|cffff7d0aLeft Click To |cff69ccf0"..Msg1.."|cffff7d0a Cast Button")
GameTooltip:AddLine("|cffff7d0aRight Click To |cff69ccf0"..Msg2.."|cffff7d0a Cast Sequence")
GameTooltip:AddLine("|cffff7d0aMiddle Click To |cff69ccf0"..Msg3.."|cffff7d0a Options")
GameTooltip:Show()
end
Rotacast.Frames.Icon:SetScript("OnEnter", function(Self, Motion)
if not Motion then return; end
IconMessage(Self)
end)
Rotacast.Frames.Icon:SetScript("OnLeave", function(Self, Motion)
if not Motion then return; end
GameTooltip:Hide()
end)
Rotacast.Frames.Icon:SetAttribute("_onclick", [=[
local Ref
if (button == "LeftButton") then
Ref = self:GetFrameRef("Rotacast.Frames.CastButton")
elseif (button == "RightButton") then
Ref = self:GetFrameRef("Rotacast.Frames.Edit.Bar")
elseif (button == "MiddleButton") then
Ref = self:GetFrameRef("Rotacast.Frames.Hotkey")
end
if Ref then
if (Ref:IsShown()) then
Ref:Hide()
if (button == "RightButton") then Ref:GetParent():Hide(); end
else
Ref:Show()
if (button == "RightButton") then Ref:GetParent():Show(); end
end
end
]=])
Rotacast.Frames.Icon:HookScript("OnClick", function(Self, Motion)
if not Self:IsMouseOver() then return; end
GameTooltip:Hide()
IconMessage(Self)
end)
Rotacast.Frames.Shield = CreateFrame("Frame", nil, UIParent)
Rotacast.Frames.Shield:SetSize(UIParent:GetWidth(), UIParent:GetHeight())
Rotacast.Frames.Shield:EnableMouse(true)
Rotacast.Frames.Shield:SetPoint("Center")
Rotacast.Frames.Shield:SetFrameStrata("High")
Rotacast.Frames.Shield:Hide()
Rotacast.Frames.GenericContainer = CreateFrame("Frame")
Rotacast.Frames.GenericFrame = CreateFrame("Cooldown", nil, Rotacast.Frames.GenericContainer, "CooldownFrameTemplate, SecureHandlerShowHideTemplate")
Rotacast.Frames.GenericFrame:HookScript("OnShow", function(Self) CooldownFrame_Set(Self, _, _, false) end)
Rotacast.Frames.GenericFrame:SetAttribute("_onshow", [=[
local Ref = self:GetFrameRef("Rotacast.Frames.CastButton")
local NextCast = Ref:GetAttribute("nextcast")
if not NextCast then return; end
Ref:SetAttribute("oldcast", NextCast)
Ref:SetAttribute("nextcast", 1)
Ref:SetAttribute("castoption", "set")
]=])
Rotacast.Frames.CastButton = CreateFrame("Button", "Rotacast.Frames.CastButton", UIParent, "ActionButtonTemplate, SecureActionButtonTemplate, SecureHandlerMouseUpDownTemplate, SecureHandlerDragTemplate, SecureHandlerAttributeTemplate")
Rotacast.Frames.CastButton:SetClampedToScreen(true)
Rotacast.Frames.CastButton:SetClampRectInsets(-70, 60, 25, -25)
Rotacast.Frames.CastButton:SetMovable(true)
Rotacast.Frames.CastButton:EnableMouse(true)
Rotacast.Frames.CastButton:SetUserPlaced(true)
Rotacast.Frames.CastButton:RegisterForClicks("AnyUp")
Rotacast.Frames.CastButton:RegisterForDrag("LeftButton")
Rotacast.Frames.CastButton:SetSize(35, 35)
Rotacast.Frames.CastButton:SetPoint("BottomRight", -60, 69)
Rotacast.Frames.CastButton:SetFrameStrata("High")
Rotacast.Frames.CastButton:SetScript("OnDragStart", Rotacast.Frames.CastButton.StartMoving)
Rotacast.Frames.CastButton:SetScript("OnDragStop", Rotacast.Frames.CastButton.StopMovingOrSizing)
local CastBackground = Rotacast.Frames.CastButton:CreateTexture(nil, "BACKGROUND")
CastBackground:SetSize(200, 100)
CastBackground:SetTexture("Interface\\ExtraButton\\AirStrike")
CastBackground:SetPoint("Center", -3, 1)
Rotacast.Frames.CastButton:SetShown(RotacastPerDB.LoadShow.Cast)
Rotacast.Frames.Icon:SetFrameRef("Rotacast.Frames.CastButton", Rotacast.Frames.CastButton)
Rotacast.Frames.GenericFrame:SetFrameRef("Rotacast.Frames.CastButton", Rotacast.Frames.CastButton)
Rotacast.Frames.Edit = {}
Rotacast.Frames.Edit.CreateMenu = CreateFrame("Frame")
Rotacast.Frames.Edit.CreateMenu.displayMode = "MENU"
UIDropDownMenu_Initialize(Rotacast.Frames.Edit.CreateMenu, function(Self, Level)
Level = Level or 1
if (Level == 1) then
local Info = UIDropDownMenu_CreateInfo()
Info.fontObject = "GameFontNormal"
Info.colorCode = "|cffff7d0a"
Info.text = "Add New Sequence"
Info.notCheckable = true
Info.func = function() Rotacast.Functions.CreateSequence() end
UIDropDownMenu_AddButton(Info, Level)
local Info = UIDropDownMenu_CreateInfo()
Info.isTitle = true
UIDropDownMenu_AddButton(Info, Level)
local Info = UIDropDownMenu_CreateInfo()
Info.fontObject = "GameFontNormal"
Info.colorCode = "|cffff7d0a"
Info.text = "Delete Current Sequence"
Info.notCheckable = true
Info.func = function() Rotacast.Functions.DeleteSequence() end
UIDropDownMenu_AddButton(Info, Level)
end
end)
Rotacast.Frames.Edit.Header = CreateFrame("Frame", "Rotacast.Frames.Edit.Header", UIParent, "TooltipBorderedFrameTemplate")
Rotacast.Frames.Edit.Header:SetSize(235, 30)
Rotacast.Frames.Edit.Header:SetMovable(true)
Rotacast.Frames.Edit.Header:EnableMouse(true)
Rotacast.Frames.Edit.Header:SetUserPlaced(true)
Rotacast.Frames.Edit.Header:RegisterForDrag("LeftButton")
Rotacast.Frames.Edit.Header:SetPoint("Top")
Rotacast.Frames.Edit.Header:SetFrameStrata("High")
Rotacast.Frames.Edit.Header:SetScript("OnDragStart", Rotacast.Frames.Edit.Header.StartMoving)
Rotacast.Frames.Edit.Header:SetScript("OnDragStop", Rotacast.Frames.Edit.Header.StopMovingOrSizing)
Rotacast.Frames.Edit.Header:SetShown(RotacastPerDB.LoadShow.Sequence)
Rotacast.Frames.Edit.Title = Rotacast.Frames.Edit.Header:CreateFontString("ARTWORK")
Rotacast.Frames.Edit.Title:SetFontObject("GameFontNormal")
Rotacast.Frames.Edit.Title:SetPoint("Left", 33, 0)
Rotacast.Frames.Edit.Title:SetTextColor(0, 1, 1, 1)
Rotacast.Frames.Edit.Title:SetText("Cast Sequence")
Rotacast.Frames.Edit.CurrentSequence = Rotacast.Frames.Edit.Header:CreateFontString("ARTWORK")
Rotacast.Frames.Edit.CurrentSequence:SetFontObject("GameFontNormal")
Rotacast.Frames.Edit.CurrentSequence:SetPoint("Left", Rotacast.Frames.Edit.Title, "Right", 2, 0)
Rotacast.Frames.Edit.CurrentSequence:SetTextColor(1, 0.96, 0.41, 1)
Rotacast.Frames.Edit.Bar = CreateFrame("Frame", "Rotacast.Frames.Edit.Bar", Rotacast.Frames.Edit.Header, "SecureHandlerAttributeTemplate, SecureHandlerShowHideTemplate")
Rotacast.Frames.Edit.Bar:SetClampedToScreen(true)
Rotacast.Frames.Edit.Bar:EnableMouse(true)
Rotacast.Frames.Edit.Bar:SetBackdrop{bgFile = "Interface\\FrameGeneral\\UI-Background-Marble", edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", tile = false,	 insets = {left = 3, right = 3, top = 3, bottom = 3}, tileSize = 32, edgeSize = 16}
Rotacast.Frames.Edit.Bar:SetSize(52, 51)
Rotacast.Frames.Edit.Bar:SetPoint("Top", 0, -27)
Rotacast.Frames.Edit.Bar:SetFrameStrata("High")
Rotacast.Frames.Edit.Bar:SetScript("OnDragStart", Rotacast.Frames.Edit.Bar.StartMoving)
Rotacast.Frames.Edit.Bar:SetScript("OnDragStop", Rotacast.Frames.Edit.Bar.StopMovingOrSizing)
Rotacast.Frames.CastButton:SetFrameRef("Rotacast.Frames.Edit.Bar", Rotacast.Frames.Edit.Bar)
Rotacast.Frames.Edit.Bar:SetFrameRef("Rotacast.Frames.CastButton", Rotacast.Frames.CastButton)
Rotacast.Frames.Icon:SetFrameRef("Rotacast.Frames.Edit.Bar", Rotacast.Frames.Edit.Bar)
Rotacast.Frames.Edit.Bar:SetFrameRef("Rotacast.Frames.Icon", Rotacast.Frames.Icon)
Rotacast.Frames.Edit.Bar:SetShown(RotacastPerDB.LoadShow.Sequence)
Rotacast.Frames.Edit.Empty = Rotacast.Frames.Edit.Bar:CreateFontString("ARTWORK")
Rotacast.Frames.Edit.Empty:SetFontObject("GameFontNormal")
Rotacast.Frames.Edit.Empty:SetFont("Fonts\\ARIALN.TTF", 13)
Rotacast.Frames.Edit.Empty:SetPoint("TopLeft", 8, -19)
Rotacast.Frames.Edit.Empty:SetText("Empty")
Rotacast.Frames.Edit.CreateSequence = CreateFrame("Button", nil, Rotacast.Frames.Edit.Header)
Rotacast.Frames.Edit.CreateSequence:SetSize(20, 20)
Rotacast.Frames.Edit.CreateSequence:SetNormalTexture("Interface\\BUTTONS\\UI-OptionsButton")
Rotacast.Frames.Edit.CreateSequence:SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Round")
Rotacast.Frames.Edit.CreateSequence:SetPoint("Left", 8, 0)
Rotacast.Frames.Edit.CreateSequence:SetScript("OnClick", function(Self)
if InCombatLockdown() then
print("|cffff7d0a"..Rotacast.Data.Title, "v"..Rotacast.Data.Version, "|cffffe00a".."Unable to create/delete sequences while in combat")
return
end
ToggleDropDownMenu(1, nil, Rotacast.Frames.Edit.CreateMenu, Self, -7, 0)
end)
Rotacast.Frames.Edit.SequenceDown = CreateFrame("Button", nil, Rotacast.Frames.Edit.Header)
Rotacast.Frames.Edit.SequenceDown:SetSize(25, 25)
Rotacast.Frames.Edit.SequenceDown:SetNormalTexture("Interface\\ChatFrame\\UI-ChatIcon-ScrollUp-Up")
Rotacast.Frames.Edit.SequenceDown:SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Round")
Rotacast.Frames.Edit.SequenceDown:SetDisabledTexture("Interface\\ChatFrame\\UI-ChatIcon-ScrollUp-Disabled")
Rotacast.Frames.Edit.SequenceDown:SetPushedTexture("Interface\\ChatFrame\\UI-ChatIcon-ScrollUp-Down")
Rotacast.Frames.Edit.SequenceDown:SetPoint("Right", -4, 0)
Rotacast.Frames.Edit.SequenceDown:SetScript("OnClick", function()
if InCombatLockdown() then
print("|cffff7d0a"..Rotacast.Data.Title, "v"..Rotacast.Data.Version, "|cffffe00a".."Unable to switch sequences while in combat")
return
end
if (RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current == 1) then
RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Max
else
RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current - 1
end
for X = 1, 100 do
Rotacast.Frames.Edit.Button[X]:Hide()
Rotacast.Frames.Edit.Button[X].Border:Hide()
end
Rotacast.Frames.CastButton:SetAttribute("nextcast", nil)
if Rotacast.Frames.CastButton.cooldown:IsVisible() then CooldownFrame_Set(Rotacast.Frames.CastButton.cooldown, _, _, false); end
Rotacast.Functions.LoadButtons()
end)
Rotacast.Frames.Edit.SequenceUp = CreateFrame("Button", nil, Rotacast.Frames.Edit.Header)
Rotacast.Frames.Edit.SequenceUp:SetSize(25, 25)
Rotacast.Frames.Edit.SequenceUp:SetNormalTexture("Interface\\ChatFrame\\UI-ChatIcon-ScrollDown-Up")
Rotacast.Frames.Edit.SequenceUp:SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Round")
Rotacast.Frames.Edit.SequenceUp:SetDisabledTexture("Interface\\ChatFrame\\UI-ChatIcon-ScrollDown-Disabled")
Rotacast.Frames.Edit.SequenceUp:SetPushedTexture("Interface\\ChatFrame\\UI-ChatIcon-ScrollDown-Down")
Rotacast.Frames.Edit.SequenceUp:SetPoint("Right", Rotacast.Frames.Edit.SequenceDown, "Left", 4, 0)
Rotacast.Frames.Edit.SequenceUp:SetScript("OnClick", function()
if InCombatLockdown() then
print("|cffff7d0a"..Rotacast.Data.Title, "v"..Rotacast.Data.Version, "|cffffe00a".."Unable to switch sequences while in combat")
return
end
if (RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current == RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Max) then
RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current = 1
else
RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current + 1
end
for X = 1, 100 do
Rotacast.Frames.Edit.Button[X]:Hide()
Rotacast.Frames.Edit.Button[X].Border:Hide()
end
Rotacast.Frames.CastButton:SetAttribute("nextcast", nil)
if Rotacast.Frames.CastButton.cooldown:IsVisible() then CooldownFrame_Set(Rotacast.Frames.CastButton.cooldown, _, _, false); end
Rotacast.Functions.LoadButtons()
end)
Rotacast.Frames.Options = CreateFrame("Frame", "Rotacast.Frames.Options", UIParent)
Rotacast.Frames.Options:SetClampedToScreen(true)
Rotacast.Frames.Options:SetClampRectInsets(0, 0, 10, 0)
Rotacast.Frames.Options:SetMovable(true)
Rotacast.Frames.Options:EnableMouse(true)
Rotacast.Frames.Options:SetUserPlaced(true)
Rotacast.Frames.Options:RegisterForDrag("LeftButton")
Rotacast.Frames.Options:SetScript("OnDragStart", Rotacast.Frames.Options.StartMoving)
Rotacast.Frames.Options:SetScript("OnDragStop", Rotacast.Frames.Options.StopMovingOrSizing)
Rotacast.Frames.Options:SetBackdrop{bgFile = "Interface\\FrameGeneral\\UI-Background-Marble", edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border", tile = false,	 insets = {left = 10, right = 10, top = 10, bottom = 10}, tileSize = 32, edgeSize = 32}
Rotacast.Frames.Options:SetSize(353, 340)
Rotacast.Frames.Options:SetPoint("Center", -65, 0)
Rotacast.Frames.Options:SetFrameStrata("High")
Rotacast.Frames.Icon:SetFrameRef("Rotacast.Frames.Hotkey", Rotacast.Frames.Options)
Rotacast.Frames.CastButton:SetFrameRef("Rotacast.Frames.Hotkey", Rotacast.Frames.Options)
Rotacast.Frames.Options.Header = Rotacast.Frames.Options:CreateTexture(nil, "ARTWORK")
Rotacast.Frames.Options.Header:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Header")
Rotacast.Frames.Options.Header:SetSize(256, 64)
Rotacast.Frames.Options.Header:SetPoint("Top", 0, 12)
Rotacast.Frames.Options.Title = Rotacast.Frames.Options:CreateFontString("ARTWORK")
Rotacast.Frames.Options.Title:SetFontObject("GameFontNormal")
Rotacast.Frames.Options.Title:SetPoint("Top", Rotacast.Frames.Options.Header, "TOP", 0, -14)
Rotacast.Frames.Options.Title:SetText("Options")
Rotacast.Frames.Options.Close = CreateFrame("Button", nil, Rotacast.Frames.Options, "UIPanelCloseButton")
Rotacast.Frames.Options.Close:SetSize(40, 40)
Rotacast.Frames.Options.Close:SetPoint("TopRight", -3, -3)
Rotacast.Frames.Binding = CreateFrame("Frame", nil, Rotacast.Frames.Options, "TooltipBorderedFrameTemplate")
Rotacast.Frames.Binding:SetSize(220, 147)
Rotacast.Frames.Binding:SetPoint("TopLeft", 20, -30)
Rotacast.Frames.Binding.Title = Rotacast.Frames.Binding:CreateFontString("ARTWORK")
Rotacast.Frames.Binding.Title:SetFont("Fonts\\FRIZQT__.TTF", 14)
Rotacast.Frames.Binding.Title:SetFontObject("GameFontNormal")
Rotacast.Frames.Binding.Title:SetTextColor(0, 1, 1, 1)
Rotacast.Frames.Binding.Title:SetPoint("Top", Rotacast.Frames.Binding, "TOP", 0, -8)
Rotacast.Frames.Binding.Title:SetText("Binding")
Rotacast.Frames.Binding.ScrollBind = Rotacast.Frames.Binding:CreateFontString("ARTWORK")
Rotacast.Frames.Binding.ScrollBind:SetFont("Fonts\\FRIZQT__.TTF", 13)
Rotacast.Frames.Binding.ScrollBind:SetFontObject("GameFontNormal")
Rotacast.Frames.Binding.ScrollBind:SetTextColor(1, 0.49, 0.04, 1)
Rotacast.Frames.Binding.ScrollBind:SetPoint("Top", 0, -30)
Rotacast.Frames.Binding.Current = Rotacast.Frames.Binding:CreateFontString("ARTWORK")
Rotacast.Frames.Binding.Current:SetFont("Fonts\\FRIZQT__.TTF", 13)
Rotacast.Frames.Binding.Current:SetFontObject("GameFontNormal")
Rotacast.Frames.Binding.Current:SetTextColor(1, 0.49, 0.04, 1)
Rotacast.Frames.Binding.Current:SetPoint("Top", 0, -50)
Rotacast.Frames.Binding.Name = CreateFrame("EditBox", nil, Rotacast.Frames.Binding, "InputBoxTemplate")
Rotacast.Frames.Binding.Name:SetTextColor(1, 0.96, 0.41, 1)
Rotacast.Frames.Binding.Name:SetSize(164, 10)
Rotacast.Frames.Binding.Name:SetPoint("Top", Rotacast.Frames.Binding.Current, "Bottom", 0, -15)
Rotacast.Frames.Binding.Name:SetScript("OnEscapePressed", function() if not InCombatLockdown() then Rotacast.Frames.Options:Hide(); end end)
Rotacast.Frames.Binding.Name:SetScript("OnKeyDown", function(Self, Key)
local Mod, Char
if (Key ~= "DELETE" and Key ~= "BACKSPACE" and Key ~= "ESCAPE") then
if IsLeftShiftKeyDown() then
Mod, Char = "LSHIFT-", Key
Self.HotkeyName = "Left Shift + "
elseif IsLeftAltKeyDown() then
Mod, Char = "LALT-", Key
Self.HotkeyName = "Left Alt + "
elseif IsLeftControlKeyDown() then
Mod, Char = "LCTRL-", Key
Self.HotkeyName = "Left Ctrl + "
elseif IsRightShiftKeyDown() then
Mod, Char = "RSHIFT-", Key
Self.HotkeyName = "Right Shift + "
elseif IsRightAltKeyDown() then
Mod, Char = "RALT-", Key
Self.HotkeyName = "Right Alt + "
elseif IsRightControlKeyDown() then
Mod, Char = "RCTRL-", Key
Self.HotkeyName = "Right Ctrl + "
else
Mod, Char = nil, Key
Self.HotkeyName = Char
end
if (Char == "LSHIFT" or Char == "LALT" or Char == "LCTRL" or Char == "RSHIFT" or Char == "RALT" or Char == "RCTRL") then Mod, Char = nil, nil; end
else
Mod, Char = nil, nil
end
if (not Mod and not Char) then
Self.HotkeyBinding = nil
Self.HotkeyName = nil
elseif (not Mod and Char) then
Self.HotkeyBinding = Char
Self.HotkeyName = Char
else
Self.HotkeyBinding = Mod..Char
Self.HotkeyName = Self.HotkeyName..Char
end
if Self.HotkeyName then
Self:SetMaxLetters(#Self.HotkeyName)
Self:SetText(Self.HotkeyName)
else
Self:SetText("")
end
end)
Rotacast.Frames.Binding.ScrollSave = CreateFrame("Button", nil, Rotacast.Frames.Binding, "UIPanelButtonTemplate, SecureHandlerMouseUpDownTemplate, SecureHandlerAttributeTemplate")
Rotacast.Frames.Binding.ScrollSave:SetSize(74, 40)
Rotacast.Frames.Binding.ScrollSave:SetPoint("Top", -55, -99)
Rotacast.Frames.Binding.ScrollSave:SetText("Scroll\nCast")
Rotacast.Frames.Binding.ScrollSave:SetAttribute("_onmouseup", [=[
local ScrollBind = self:GetAttribute("rotacastperdb.scrollbind")
if (ScrollBind == "On") then ScrollBind = "Off"; elseif (ScrollBind == "Off") then ScrollBind = "On"; end
self:SetAttribute("rotacastperdb.scrollbind", ScrollBind)
]=])
Rotacast.Frames.Binding.ScrollSave:SetAttribute("_onattributechanged", [=[
if (name == "rotacastperdb.scrollbind") then
local Ref = self:GetFrameRef("Rotacast.Frames.CastButton")
if (value == "On") then
Ref:SetBindingClick(false, "MOUSEWHEELUP", Ref:GetName(), "LeftButton")
Ref:SetBindingClick(false, "MOUSEWHEELDOWN", Ref:GetName(), "LeftButton")
elseif (value == "Off") then
Ref:ClearBinding("MOUSEWHEELUP")
Ref:ClearBinding("MOUSEWHEELDOWN")
end
end
]=])
Rotacast.Frames.Binding.ScrollSave:HookScript("OnAttributeChanged", function(Self, Name, Value)
if (Name == "rotacastperdb.scrollbind") then
RotacastPerDB.ScrollBind = Value
Rotacast.Frames.Binding.ScrollBind:SetText("Scroll Cast: |cffffe00a"..RotacastPerDB.ScrollBind)
end
end)
Rotacast.Frames.Binding.ScrollSave:SetFrameRef("Rotacast.Frames.CastButton", Rotacast.Frames.CastButton)
Rotacast.Frames.Binding.ScrollSave:SetFrameRef("Rotacast.Frames.Hotkey", Rotacast.Frames.Options)
Rotacast.Frames.Binding.ScrollSave:SetAttribute("rotacastperdb.scrollbind", RotacastPerDB.ScrollBind)
Rotacast.Frames.Binding.KeySave = CreateFrame("Button", nil, Rotacast.Frames.Binding, "UIPanelButtonTemplate, SecureHandlerAttributeTemplate")
Rotacast.Frames.Binding.KeySave:SetSize(74, 40)
Rotacast.Frames.Binding.KeySave:SetPoint("Top", 55, -99)
Rotacast.Frames.Binding.KeySave:SetText("Set\nHotkey")
Rotacast.Frames.Binding.KeySave:HookScript("OnClick", function(Self)
if InCombatLockdown() then
print("|cffff7d0a"..Rotacast.Data.Title, "v"..Rotacast.Data.Version, "|cffffe00a".."Unable to modify hotkey while in combat")
else
Self:SetAttribute("oldkeybind", RotacastPerDB.HotkeyBinding)
Self:SetAttribute("newkeyname", Rotacast.Frames.Binding.Name.HotkeyName)
Self:SetAttribute("newkeybind", Rotacast.Frames.Binding.Name.HotkeyBinding)
end
end)
Rotacast.Frames.Binding.KeySave:SetAttribute("_onattributechanged", [=[
if (name == "newkeybind") then
local Ref = self:GetFrameRef("Rotacast.Frames.CastButton")
local OldKeyBind = self:GetAttribute("oldkeybind")
if OldKeyBind then Ref:ClearBinding(OldKeyBind); end
if value then Ref:SetBindingClick(false, value, Ref:GetName(), "LeftButton"); end
end
]=])
Rotacast.Frames.Binding.KeySave:HookScript("OnAttributeChanged", function(Self, Name, Value)
if (Name == "newkeybind") then
RotacastPerDB.HotKeyName, RotacastPerDB.HotkeyBinding = Self:GetAttribute("newkeyname"), Self:GetAttribute("newkeybind")
if RotacastPerDB.HotKeyName then Rotacast.Frames.Binding.Current:SetText("Hotkey: |cffffe00a"..RotacastPerDB.HotKeyName); else Rotacast.Frames.Binding.Current:SetText("Hotkey: |cffffe00aNone"); end
end
end)
Rotacast.Frames.Binding.KeySave:HookScript("OnHide", function(Self)
Rotacast.Frames.Binding.Name.HotkeyName, Rotacast.Frames.Binding.Name.HotkeyBinding = nil, nil
Rotacast.Frames.Binding.Name:SetText("")
end)
Rotacast.Frames.Binding.KeySave:SetFrameRef("Rotacast.Frames.CastButton", Rotacast.Frames.CastButton)
Rotacast.Frames.Binding.KeySave:SetFrameRef("Rotacast.Frames.Hotkey", Rotacast.Frames.Options)
Rotacast.Frames.Binding.KeySave:SetAttribute("oldkeybind", RotacastPerDB.HotkeyBinding)
Rotacast.Frames.Binding.KeySave:SetAttribute("newkeyname", RotacastPerDB.HotKeyName)
Rotacast.Frames.Binding.KeySave:SetAttribute("newkeybind", RotacastPerDB.HotkeyBinding)
Rotacast.Frames.Options:SetShown(RotacastPerDB.LoadShow.Binding)
Rotacast.Frames.Reset = CreateFrame("Frame", nil, Rotacast.Frames.Options, "TooltipBorderedFrameTemplate")
Rotacast.Frames.Reset:SetSize(220, 140)
Rotacast.Frames.Reset:SetPoint("Top", Rotacast.Frames.Binding, "Bottom", 0, -5)
Rotacast.Frames.Reset.Title = Rotacast.Frames.Reset:CreateFontString("ARTWORK")
Rotacast.Frames.Reset.Title:SetFont("Fonts\\FRIZQT__.TTF", 14)
Rotacast.Frames.Reset.Title:SetFontObject("GameFontNormal")
Rotacast.Frames.Reset.Title:SetTextColor(0, 1, 1, 1)
Rotacast.Frames.Reset.Title:SetPoint("Top", Rotacast.Frames.Reset, "TOP", 0, -8)
Rotacast.Frames.Reset.Title:SetText("Cast Sequence")
Rotacast.Frames.Reset.Options1 = CreateFrame("CheckButton", "ResetOptions1", Rotacast.Frames.Reset, "UICheckButtonTemplate")
Rotacast.Frames.Reset.Options1:SetSize(25, 25)
Rotacast.Frames.Reset.Options1:SetPoint("TopLeft", 8, -25)
ResetOptions1Text:SetFont("Fonts\\FRIZQT__.TTF", 12)
ResetOptions1Text:SetFontObject("GameFontNormal")
ResetOptions1Text:SetText("|cffff7d0aOnly Reset During Combat")
Rotacast.Frames.Reset.Options1:SetHitRectInsets(0,-(ResetOptions1Text:GetWidth()),0,0)
Rotacast.Frames.Reset.Options1:SetChecked(RotacastPerDB.SequenceOptions.Combat)
Rotacast.Frames.Reset.Options1:HookScript("OnClick", function(Self) RotacastPerDB.SequenceOptions.Combat = Self:GetChecked() end)
Rotacast.Frames.Reset.Options2 = CreateFrame("CheckButton", "ResetOptions2", Rotacast.Frames.Reset, "UICheckButtonTemplate")
Rotacast.Frames.Reset.Options2:SetSize(25, 25)
Rotacast.Frames.Reset.Options2:SetPoint("Top", Rotacast.Frames.Reset.Options1, "Bottom", 0, 5)
ResetOptions2Text:SetFont("Fonts\\FRIZQT__.TTF", 12)
ResetOptions2Text:SetFontObject("GameFontNormal")
ResetOptions2Text:SetText("|cffff7d0aReset On Entering Combat")
Rotacast.Frames.Reset.Options2:SetHitRectInsets(0,-(ResetOptions2Text:GetWidth()),0,0)
Rotacast.Frames.Reset.Options2:SetChecked(RotacastPerDB.SequenceOptions.Enter)
Rotacast.Frames.Reset.Options2:HookScript("OnClick", function(Self) RotacastPerDB.SequenceOptions.Enter = Self:GetChecked() end)
Rotacast.Frames.Reset.Options3 = CreateFrame("CheckButton", "ResetOptions3", Rotacast.Frames.Reset, "UICheckButtonTemplate")
Rotacast.Frames.Reset.Options3:SetSize(25, 25)
Rotacast.Frames.Reset.Options3:SetPoint("Top", Rotacast.Frames.Reset.Options2, "Bottom", 0, 5)
ResetOptions3Text:SetFont("Fonts\\FRIZQT__.TTF", 12)
ResetOptions3Text:SetFontObject("GameFontNormal")
ResetOptions3Text:SetText("|cffff7d0aReset On Leaving Combat")
Rotacast.Frames.Reset.Options3:SetHitRectInsets(0,-(ResetOptions3Text:GetWidth()),0,0)
Rotacast.Frames.Reset.Options3:SetChecked(RotacastPerDB.SequenceOptions.Leave)
Rotacast.Frames.Reset.Options3:HookScript("OnClick", function(Self) RotacastPerDB.SequenceOptions.Leave = Self:GetChecked() end)
Rotacast.Frames.Reset.Options4 = CreateFrame("CheckButton", "ResetOptions4", Rotacast.Frames.Reset, "UICheckButtonTemplate")
Rotacast.Frames.Reset.Options4:SetSize(25, 25)
Rotacast.Frames.Reset.Options4:SetPoint("Top", Rotacast.Frames.Reset.Options3, "Bottom", 0, 5)
ResetOptions4Text:SetFont("Fonts\\FRIZQT__.TTF", 12)
ResetOptions4Text:SetFontObject("GameFontNormal")
ResetOptions4Text:SetText("|cffff7d0aReset On Target Switch")
Rotacast.Frames.Reset.Options4:SetHitRectInsets(0,-(ResetOptions4Text:GetWidth()),0,0)
Rotacast.Frames.Reset.Options4:SetChecked(RotacastPerDB.SequenceOptions.Switch)
Rotacast.Frames.Reset.Options4:HookScript("OnClick", function(Self) RotacastPerDB.SequenceOptions.Switch = Self:GetChecked() end)
Rotacast.Frames.Reset.Options5 = CreateFrame("CheckButton", "ResetOptions5", Rotacast.Frames.Reset, "UICheckButtonTemplate")
Rotacast.Frames.Reset.Options5:SetSize(25, 25)
Rotacast.Frames.Reset.Options5:SetPoint("Top", Rotacast.Frames.Reset.Options4, "Bottom", 0, 5)
ResetOptions5Text:SetFont("Fonts\\FRIZQT__.TTF", 12)
ResetOptions5Text:SetFontObject("GameFontNormal")
ResetOptions5Text:SetText("|cffff7d0aUse Sequence 1 As Default")
Rotacast.Frames.Reset.Options5:SetHitRectInsets(0,-(ResetOptions5Text:GetWidth()),0,0)


Rotacast.Frames.Reset.Options5:SetChecked(RotacastPerDB.SequenceOptions.Default)
Rotacast.Frames.Reset.Options5:HookScript("OnClick", function(Self) RotacastPerDB.SequenceOptions.Default = Self:GetChecked() end)

Rotacast.Frames.Guide = CreateFrame("Button", nil, Rotacast.Frames.Options, "SecureHandlerClickTemplate")
Rotacast.Frames.Guide:EnableMouse(true)
Rotacast.Frames.Guide:SetSize(55, 55)
Rotacast.Frames.Guide:SetPoint("BottomRight", -10, 10)
Rotacast.Frames.Guide:SetFrameStrata("High")
Rotacast.Frames.Guide:SetAlpha(1)
Rotacast.Frames.Guide:SetHighlightTexture(136477)
local Icon = Rotacast.Frames.Guide:CreateTexture(nil, "ARTWORK")
Icon:SetTexture("Interface\\COMMON\\help-i")
Icon:SetSize(70, 70)
Icon:SetPoint("Center", 0, 0)
Rotacast.Frames.Guide:SetFrameRef("Rotacast.Frames.GuideDisplay", Rotacast.Frames.GuideDisplay)
Rotacast.Frames.Guide:SetAttribute("_onclick", [=[
local Ref = self:GetFrameRef("Rotacast.Frames.GuideDisplay")
if Ref:IsVisible() then Ref:Hide(); else Ref:Show(); end
]=])
Rotacast.Frames.Restore = CreateFrame("Button", nil, Rotacast.Frames.Options, "UIPanelButtonTemplate")
Rotacast.Frames.Restore:SetSize(84, 60)
Rotacast.Frames.Restore:SetText("Restore\nDefault\nPositions")
Rotacast.Frames.Restore:SetPoint("TopLeft", 249, -180)
Rotacast.Frames.Restore:HookScript("OnClick", function()
if InCombatLockdown() then
print("|cffff7d0a"..Rotacast.Data.Title, "v"..Rotacast.Data.Version, "|cffffe00a".."Unable to restore default positions while in combat")
else
Rotacast.Frames.CastButton:ClearAllPoints()
Rotacast.Frames.CastButton:SetPoint("BottomRight", -60, 69)
Rotacast.Frames.Edit.Header:ClearAllPoints()
Rotacast.Frames.Edit.Header:SetPoint("Top")
Rotacast.Frames.Options:ClearAllPoints()
Rotacast.Frames.Options:SetPoint("Center", -65, 0)
Rotacast.Frames.Icon.ClearAllPoints, Rotacast.Frames.Icon.SetPoint = UIParent.ClearAllPoints, UIParent.SetPoint
Rotacast.Frames.Icon:ClearAllPoints()
Rotacast.Frames.Icon:SetPoint("BottomRight")
Rotacast.Frames.GuideDisplay:ClearAllPoints()
Rotacast.Frames.GuideDisplay:SetPoint("Right", -45, 30)
end
end)
Rotacast.Frames.Edit.Button = {}
local Left, Top = 9, -9
for X = 1, 100 do
Rotacast.Frames.Edit.Button[X] = CreateFrame("Button", nil, Rotacast.Frames.Edit.Bar, "ActionButtonTemplate, SecureActionButtonTemplate, SecureHandlerMouseUpDownTemplate, SecureHandlerDragTemplate")
Rotacast.Frames.Edit.Button[X]:RegisterForClicks("AnyUp")
Rotacast.Frames.Edit.Button[X]:RegisterForDrag("LeftButton")
Rotacast.Frames.Edit.Button[X]:SetSize(35, 35)
Rotacast.Frames.Edit.Button[X]:SetPoint("TopLeft", Left, Top)
Rotacast.Frames.Edit.Button[X]:SetID(X)
Rotacast.Frames.Edit.Button[X].Border:SetTexture(130744)
Rotacast.Frames.Edit.Button[X]:Hide()
Rotacast.Frames.CastButton:SetFrameRef("Rotacast"..X, Rotacast.Frames.Edit.Button[X])
Rotacast.Frames.Edit.Button[X]:SetFrameRef("Rotacast.Frames.CastButton", Rotacast.Frames.CastButton)
Rotacast.Frames.Edit.Button[X]:SetAttribute("_onreceivedrag", [=[
local CastID
if (kind == "spell") then
CastID = select(2, ...)
end
if (kind == "spell") then
local Ref = self:GetFrameRef("Rotacast.Frames.CastButton")
self:SetAttribute("castid", CastID)
if (kind == "spell") then
self:SetAttribute("spell", CastID)
self:SetAttribute("newspell", CastID)
return "clear"
end
elseif (not kind and not value) then
local Ref = self:GetFrameRef("Rotacast.Frames.CastButton")
local SwapButton = Ref:GetAttribute("swapbutton1")
local SwapSpell = Ref:GetAttribute("swapspell1")
if (SwapButton and SwapSpell) then
Ref:SetAttribute("swapbutton2", self:GetID())
Ref:SetAttribute("swapspell2", self:GetAttribute("castid"))
Ref:SetAttribute("option", "swap")
end
Ref:SetAttribute("swapbutton1", nil)
Ref:SetAttribute("swapspell1", nil)
return "clear"
end
]=])
Rotacast.Frames.Edit.Button[X]:HookScript("OnReceiveDrag", function(Self)
local Type, Data, _, _ = GetCursorInfo()
if (Type == "macro") then
if not InCombatLockdown() then
local CastID = GetMacroBody(Data)
Self:SetAttribute("castid", CastID)
Self:SetAttribute("macroid", Data)
Self:SetAttribute("newspell", CastID)
else
print("|cffff7d0a"..Rotacast.Data.Title, "v"..Rotacast.Data.Version, "|cffffe00a".."Unable to add macros while in combat")
end
end
ClearCursor()
end)
Rotacast.Frames.Edit.Button[X]:HookScript("OnAttributeChanged", function(Self, Name, Value)
if (Name == "newspell") then
local DisplayInfo, Icon
if (type(Value) == "number") then
DisplayInfo = Value
else
Data1, Data2, Data3 = GetMacroInfo(Self:GetAttribute("macroid"))
DisplayInfo = {["Name"] = Data1, ["Texture"] = Data2, ["Body"] = Data3}
end
if (type(DisplayInfo) == "table") then
Icon = DisplayInfo.Texture
else
_, _, Icon, _, _, _, _ = GetSpellInfo(Value)
end
Self.icon:SetTexture(Icon)
RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][Self:GetID()] = DisplayInfo
GameTooltip:Hide()
GameTooltip:SetOwner(Self, "ANCHOR_TOPLEFT")
local CastID = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][X]
if (type(CastID) == "table") then
GameTooltip:SetText(CastID.Name)
GameTooltip:AddLine("|cffff7d0a"..CastID.Body)
else
GameTooltip:SetSpellByID(CastID)
end
GameTooltip:Show()
if (Self:GetID() == Rotacast.Frames.CastButton:GetAttribute("nextcast")) then
Rotacast.Frames.CastButton.icon:SetTexture(Icon)
Rotacast.Functions.UpdateCooldown()
end
end
end)
Rotacast.Frames.Edit.Button[X]:SetAttribute("_ondragstart", [=[
local Ref = self:GetFrameRef("Rotacast.Frames.CastButton")
local SwapButton = self:GetID()
local SwapSpell = self:GetAttribute("castid")
Ref:SetAttribute("swapbutton1", SwapButton)
Ref:SetAttribute("swapspell1", SwapSpell)
]=])
Rotacast.Frames.Edit.Button[X]:HookScript("OnDragStart", function(Self)
Rotacast.Frames.Shield:SetShown(true)
local DisplayID, Icon = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][Self:GetID()]
if (type(DisplayID) == "table") then Icon = "Interface\\CURSOR\\WorkOrders"; else Icon = GetSpellTextureFileName(DisplayID); end
SetCursor(Icon)
PlaySound("igSpellBookSpellIconPickup")
end)
Rotacast.Frames.Edit.Button[X]:HookScript("OnDragStop", function(Self)
Rotacast.Frames.Shield:SetShown(false)
ResetCursor()
PlaySound("igSpellBookSpellIconDrop")
end)
Rotacast.Frames.Edit.Button[X]:SetAttribute("_onmouseup", [=[
local Ref = self:GetFrameRef("Rotacast.Frames.CastButton")
if (button == "RightButton") then
Ref:SetAttribute("deleteid", self:GetID())
Ref:SetAttribute("option", "delete")
elseif (button == "LeftButton") then
Ref:SetAttribute("oldcast", Ref:GetAttribute("nextcast"))
Ref:SetAttribute("nextcast", self:GetID())
Ref:SetAttribute("castoption", "set")
end
]=])
Rotacast.Frames.Edit.Button[X]:HookScript("OnClick", function(Self, Button)
if (Button == "LeftButton") then
if Rotacast.Frames.CastButton.cooldown:IsVisible() then
CooldownFrame_Set(Rotacast.Frames.CastButton.cooldown, _, _, false)
Rotacast.Functions.UpdateCooldown()
end
end
end)
Rotacast.Frames.Edit.Button[X]:SetScript("OnEnter", function(Self, Motion)
GameTooltip:SetOwner(Self, "ANCHOR_TOPLEFT")
local CastID = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][X]
if (type(CastID) == "table") then
GameTooltip:SetText(CastID.Name)
GameTooltip:AddLine("|cffff7d0a"..CastID.Body)
else
GameTooltip:SetSpellByID(CastID)
end
GameTooltip:Show()
end)
Rotacast.Frames.Edit.Button[X]:SetScript("OnLeave", function(Self, Motion)
if not Motion then return; end
GameTooltip:Hide()
end)
if (Left == 459) then Left, Top = 9, Top - 50; else Left = Left + 50; end
end
Rotacast.Frames.CastButton:SetAttribute("_onmouseup", [=[
local NextCast = self:GetAttribute("nextcast")
if (button == "RightButton") then
--Reset Queue
if not NextCast then return; end
self:SetAttribute("oldcast", NextCast)
self:SetAttribute("nextcast", 1)
self:SetAttribute("castoption", "set")
elseif (button == "LeftButton") then
--Cast Spell
if NextCast then
local NumButtons = self:GetAttribute("numbuttons")
local Ref = self:GetFrameRef("Rotacast"..NextCast)
local CastID = Ref:GetAttribute("castid")
local CastName = self:GetAttribute("SpellList"..CastID)
local CastType
if (type(CastID) == "string") then
CastType = CastID
self:SetAttribute("*type1", "macro")
self:SetAttribute("macrotext", CastType)
else
if CastName then
CastType = "/cast "..CastName
self:SetAttribute("*type1", "macro")
self:SetAttribute("macrotext", CastType)
else
CastType = CastID
self:SetAttribute("*type1", "spell")
self:SetAttribute("spell", CastType)
end
end
self:SetAttribute("oldcast", NextCast)
if (NextCast == NumButtons) then NextCast = 1; else NextCast = NextCast + 1; end
self:SetAttribute("nextcast", NextCast)
self:SetAttribute("castoption", "set")
else
self:SetAttribute("*type1", nil)
end
end
]=])
Rotacast.Frames.CastButton:SetAttribute("_onreceivedrag", [=[
local CastID
if (kind == "spell") then CastID = select(2, ...); end
local NumButtons = self:GetAttribute("numbuttons")
if (NumButtons >= 100) then
print("|cffff7d0a".."Rotacast", "|cffffe00a".."Spell Queue Is Full!")
return "clear"
end
if (kind == "spell") then
NumButtons = NumButtons + 1
local Ref = self:GetFrameRef("Rotacast"..NumButtons)
Ref:SetAttribute("castid", CastID)
Ref:Show()
local Ref = self:GetFrameRef("Rotacast.Frames.Edit.Bar")
Ref:SetAttribute("numbuttons", NumButtons)
self:SetAttribute("numbuttons", NumButtons)
self:SetAttribute("newspell", CastID)
self:SetAttribute("option", "add")
end
]=])
Rotacast.Frames.CastButton:HookScript("OnReceiveDrag", function(Self)
local Type, Data, _, _ = GetCursorInfo()
if (Type == "macro") then
if not InCombatLockdown() then
local NumButtons = Self:GetAttribute("numbuttons")
if (NumButtons >= 100) then
print("|cffff7d0a".."Rotacast", "|cffffe00a".."Spell Queue Is Full!")
return
end
NumButtons = NumButtons + 1
local Ref = Rotacast.Frames.Edit.Button[NumButtons]
local CastID = GetMacroBody(Data)
Ref:SetAttribute("castid", CastID)
Ref:Show()
Rotacast.Frames.Edit.Bar:SetAttribute("numbuttons", NumButtons)
Self:SetAttribute("numbuttons", NumButtons)
Self:SetAttribute("spellid", Data)
Self:SetAttribute("newspell", CastID)
Self:SetAttribute("option", "add")
else
print("|cffff7d0a"..Rotacast.Data.Title, "v"..Rotacast.Data.Version, "|cffffe00a".."Unable to add macros while in combat")
end
end
ClearCursor()
end)
Rotacast.Frames.CastButton:SetAttribute("_onattributechanged", [=[
if (name == "option") then
if (value == "add") then
if not self:GetAttribute("nextcast") then
self:SetAttribute("nextcast", 1)
self:SetAttribute("castoption", "set")
end
elseif (value == "swap") then
local SwapButton1 = self:GetAttribute("swapbutton1")
local SwapSpell1 = self:GetAttribute("swapspell1")
local SwapButton2 = self:GetAttribute("swapbutton2")
local SwapSpell2 = self:GetAttribute("swapspell2")
local Ref = self:GetFrameRef("Rotacast"..SwapButton1)
Ref:SetAttribute("castid", SwapSpell2)
local Ref = self:GetFrameRef("Rotacast"..SwapButton2)
Ref:SetAttribute("castid", SwapSpell1)
elseif (value == "delete") then
local DeleteID = self:GetAttribute("deleteid")
local NextCast = self:GetAttribute("nextcast")
local NumButtons = self:GetAttribute("numbuttons")
local Ref
local Index = 0
for X = 1, NumButtons do
Ref = self:GetFrameRef("Rotacast"..X)
if (X ~= DeleteID) then
Index = Index + 1
local Ref2 = self:GetFrameRef("Rotacast"..Index)
Ref2:SetAttribute("castid", Ref:GetAttribute("castid"))
end
end
Ref:Hide()
NumButtons = NumButtons - 1
local Ref = self:GetFrameRef("Rotacast.Frames.Edit.Bar")
self:SetAttribute("numbuttons", NumButtons)
Ref:SetAttribute("numbuttons", NumButtons)
local Clicked, First = DeleteID
if (Clicked > NextCast) then
First = NextCast
elseif (Clicked < NextCast) then
First = NextCast - 1
elseif (Clicked == NextCast) then
if (NextCast >= NumButtons) then First = NumButtons; else First = NextCast; end
end
if (First == 0) then First = nil; end
self:SetAttribute("oldcast", NextCast)
self:SetAttribute("nextcast", First)
self:SetAttribute("castoption", "delete")
end
elseif (name == "hotkeybinding" and value) then
self:SetBindingClick(false, value, self:GetName(), "LeftButton")
end
]=])
Rotacast.Frames.CastButton:SetAttribute("hotkeybinding", RotacastPerDB.HotkeyBinding)
Rotacast.Frames.CastButton:HookScript("OnAttributeChanged", function(Self, Name, Value)
if (Name == "option") then
if (Value == "add") then
local GetSpell, AddSpell = Self:GetAttribute("newspell")
if (type(GetSpell) == "number") then
AddSpell = GetSpell
else
Data1, Data2, Data3 = GetMacroInfo(Self:GetAttribute("spellid"))
AddSpell = {["Name"] = Data1, ["Texture"] = Data2, ["Body"] = Data3}
end
table.insert(RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current], AddSpell)
if (#RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current] == 1) then
local DisplayID, Icon = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][1]
if (type(DisplayID) == "table") then
Icon = DisplayID.Texture
else
_, _, Icon, _, _, _, _ = GetSpellInfo(DisplayID)
end
Self.icon:SetTexture(Icon)
Rotacast.Frames.Edit.Button[1].Border:Show()
end
elseif (Value == "swap") then
local SwapButton1 = Self:GetAttribute("swapbutton1")
local SwapSpell1 = Self:GetAttribute("swapspell1")
local SwapButton2 = Self:GetAttribute("swapbutton2")
local SwapSpell2 = Self:GetAttribute("swapspell2")
local Swap1, Swap2 = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][SwapButton1], RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][SwapButton2]
RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][SwapButton1] = Swap2
RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][SwapButton2] = Swap1
GameTooltip:Hide()
GameTooltip:SetOwner(Rotacast.Frames.Edit.Button[SwapButton2], "ANCHOR_TOPLEFT")
local CastID = SwapSpell1
if (type(SwapSpell1) == "string") then
GameTooltip:SetText(RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][SwapButton2].Name)
GameTooltip:AddLine("|cffff7d0a"..RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][SwapButton2].Body)
else
GameTooltip:SetSpellByID(SwapSpell1)
end
GameTooltip:Show()
elseif (Value == "delete") then
GameTooltip:Hide()
table.remove(RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current], Self:GetAttribute("deleteid"))
PlaySound("TalentScreenOpen")
end
local CastIcon
for X = 1, #RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current] do
local DisplayID, Icon = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][X]
if (type(DisplayID) == "table") then
Icon = DisplayID.Texture
else
_, _, Icon, _, _, _, _ = GetSpellInfo(DisplayID)
end
Rotacast.Frames.Edit.Button[X].icon:SetTexture(Icon)
if Rotacast.Frames.Edit.Button[X].Border:IsVisible() then CastIcon = Rotacast.Frames.Edit.Button[X].icon:GetTexture(); end
end
Self.icon:SetTexture(CastIcon or 134400)
elseif (Name == "castoption") then
if (Value == "set") then
if (#RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current] == 0) then return; end
local Index = Self:GetAttribute("nextcast")
local DisplayID, Icon = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][Index]
if (type(DisplayID) == "table") then
Icon = DisplayID.Texture
else
_, _, Icon, _, _, _, _ = GetSpellInfo(DisplayID)
end
Self.icon:SetTexture(Icon)
local OldCast = Self:GetAttribute("oldcast")
if OldCast then Rotacast.Frames.Edit.Button[OldCast].Border:Hide(); end
Rotacast.Frames.Edit.Button[Index].Border:Show()
Rotacast.Functions.UpdateCooldown()
elseif (Value == "delete") then
local Index = Self:GetAttribute("nextcast")
local OldCast = Self:GetAttribute("oldcast")
if OldCast then Rotacast.Frames.Edit.Button[OldCast].Border:Hide(); end
if Index then Rotacast.Frames.Edit.Button[Index].Border:Show(); end
Rotacast.Functions.UpdateCooldown()
end
end
end)
Rotacast.Frames.Edit.Bar:SetAttribute("_onattributechanged", [=[
if (name == "loadshow") then
local Ref = self:GetFrameRef("Rotacast.Frames.Icon")
Ref:SetBindingClick(false, "ESCAPE", Ref:GetName(), "RightButton")
end
if (name == "numbuttons") then
if (value ~= 0) then
local Height, Width = math.ceil(value / 10)
if (value > 10) then Width = 10; else Width = value; end
self:SetWidth((Width * 50) + 2); self:SetHeight((Height * 50) + 1)
end
end
]=])
Rotacast.Frames.Edit.Bar:HookScript("OnAttributeChanged", function(Self, Name, Value)
if (Name == "numbuttons") then
local Height, Width = Self:GetHeight()
if (Value < 5) then Width = 0; else Width = (Self:GetWidth() / 2) - 100; end
Rotacast.Frames.Edit.Header:SetClampedToScreen(true)
Rotacast.Frames.Edit.Header:SetClampRectInsets(-Width, Width, 0, -Height)
end
end)
if (RotacastPerDB.LoadShow.Sequence == true) then Rotacast.Frames.Edit.Bar:SetAttribute("loadshow", true); end
Rotacast.Frames.CastButton:HookScript("OnShow", function() RotacastPerDB.LoadShow.Cast = true; PlaySound("igCharacterInfoOpen") end)
Rotacast.Frames.CastButton:HookScript("OnHide", function() RotacastPerDB.LoadShow.Cast = false; PlaySound("igCharacterInfoClose") end)
Rotacast.Frames.Edit.Bar:SetAttribute("_onshow", [=[
local Ref = self:GetFrameRef("Rotacast.Frames.Icon")
Ref:SetBindingClick(false, "ESCAPE", Ref:GetName(), "RightButton")
]=])
Rotacast.Frames.Edit.Bar:HookScript("OnShow", function() RotacastPerDB.LoadShow.Sequence = true; PlaySound("igCharacterInfoOpen") end)
Rotacast.Frames.Edit.Bar:HookScript("OnHide", function()
GameTooltip:Hide()
CloseDropDownMenus()
RotacastPerDB.LoadShow.Sequence = false
PlaySound("igCharacterInfoClose")
end)
Rotacast.Frames.Edit.Bar:SetAttribute("_onhide", [=[
local Ref = self:GetFrameRef("Rotacast.Frames.Icon")
Ref:ClearBinding("ESCAPE")
]=])
Rotacast.Frames.Options:HookScript("OnShow", function() RotacastPerDB.LoadShow.Binding = true; PlaySound("igCharacterInfoOpen") end)
Rotacast.Frames.Options:HookScript("OnHide", function()
RotacastPerDB.LoadShow.Binding = false
if Rotacast.Frames.Icon:IsMouseOver() then GameTooltip:Hide(); IconMessage(Rotacast.Frames.Icon); end;
PlaySound("igCharacterInfoClose")
end)
end
function Rotacast.Functions.UpdateCooldown()
local NextCast = Rotacast.Frames.CastButton:GetAttribute("nextcast")
if NextCast then
local CastID = Rotacast.Frames.Edit.Button[NextCast]:GetAttribute("castid")
if not CastID then return; end
local Start, Duration, SpellID
if (type(CastID) == "string") then _, _, SpellID = GetMacroSpell(Rotacast.Functions.FindMacro(CastID)); else SpellID = CastID; end
if SpellID then Start, Duration, _ = GetSpellCooldown(SpellID); end
if (Start and Duration) then CooldownFrame_Set(Rotacast.Frames.CastButton.cooldown, Start, Duration, true); end
else
CooldownFrame_Set(Rotacast.Frames.CastButton.cooldown, _, _, false)
end
end
function Rotacast.Functions.UpdateIconsTalent()
local Index = Rotacast.Frames.CastButton:GetAttribute("nextcast")
local DisplayID, Icon = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][Index]
if (type(DisplayID) == "table") then Icon = DisplayID.Texture; else _, _, Icon, _, _, _, _ = GetSpellInfo(DisplayID); end
Rotacast.Frames.CastButton.icon:SetTexture(Icon)
for X = 1, #RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current] do
local DisplayID, Icon = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][X]
if (type(DisplayID) == "table") then Icon = DisplayID.Texture; else _, _, Icon, _, _, _, _ = GetSpellInfo(DisplayID); end
Rotacast.Frames.Edit.Button[X].icon:SetTexture(Icon)
end
end
function Rotacast.Functions.FindMacro(Data)
for X = 1, 138 do
if (GetMacroBody(X) == Data) then return X; end
end
end
function Rotacast.Functions.SetSpells()
for X = 1, GetNumSpellTabs() do
local _, _, Min, Max = GetSpellTabInfo(X)
for I = (Min + 1), (Min + Max) do
local Name, _, _, _, _, _, SpellID = GetSpellInfo(I, "spell")
if (Name and SpellID) then Rotacast.Frames.CastButton:SetAttribute("SpellList"..SpellID, Name); end
end
end
end
function Rotacast.Functions.Generic(Event, ...)
for X = 1, select("#", ...) do
local Data = select(X, ...)
Data:UnregisterEvent(Event)
end
end
function Rotacast.Functions.DBUpdateMacros()
local MacrosUpdated
for X = 1, #RotacastPerDB.Buttons do
if (type(RotacastPerDB.Buttons[X]) == "number") then
if (RotacastPerDB.Buttons[X] >= 1000000) then
local Macro = RotacastPerDB.Buttons[X] - 1000000
local Name, Texture, Body = GetMacroInfo(Macro)
local AddMacro = {["Name"] = Name, ["Texture"] = Texture, ["Body"] = Body}
RotacastPerDB.Buttons[X] = AddMacro
Rotacast.Frames.Edit.Button[X]:SetAttribute("castid", AddMacro.Body)
MacrosUpdated = true
end
end
end
if MacrosUpdated then print("|cffff7d0a"..Rotacast.Data.Title, "v"..Rotacast.Data.Version, "|cffffe00a".."Macros successfully converted"); end
end
function Rotacast.Functions.SpecData()
Rotacast.Data.CurrentSpec = GetSpecializationInfo(GetSpecialization())
if not RotacastPerDB.SpecData then
RotacastPerDB.SpecData = {}
local _, _, ClassID = UnitClass("player")
for X = 1, GetNumSpecializations() do
local ID, _, _, _, _, _ = GetSpecializationInfoForClassID(ClassID, X)
RotacastPerDB.SpecData[ID] = {["Max"] = 1, ["Current"] = 1, ["Buttons"] = {[1] = {}}}
end
for X = 1, #RotacastPerDB.Buttons do
table.insert(RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[1], RotacastPerDB.Buttons[X])
end
RotacastPerDB.Version = 1.5
end
end
function Rotacast.Functions.LoadButtons()
Rotacast.Frames.CastButton:SetAttribute("numbuttons", #RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current])
Rotacast.Functions.SetSpells()
local CastID, Icon
for X = 1, #RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current] do
if (type(RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][X]) == "table") then
CastID, Icon = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][X].Body, RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][X].Texture
else
CastID = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][X]
_, _, Icon, _, _, _, _ = GetSpellInfo(RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][X])
if not Rotacast.Frames.CastButton:GetAttribute("SpellList"..CastID) then
local Name, _, _, _, _, _, _ = GetSpellInfo(CastID)
Rotacast.Frames.CastButton:SetAttribute("SpellList"..CastID, Name)
end
end
Rotacast.Frames.Edit.Button[X].icon:SetTexture(Icon)
Rotacast.Frames.Edit.Button[X]:Show()
Rotacast.Frames.Edit.Button[X]:SetAttribute("castid", CastID)
end
Rotacast.Frames.CastButton.icon:SetTexture(134400)
if (#RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current] ~= 0) then
Rotacast.Frames.CastButton:SetAttribute("nextcast", 1)
Rotacast.Frames.CastButton:SetAttribute("castoption", "set")
else
Rotacast.Frames.Edit.Bar:SetSize(52, 51)
end
Rotacast.Frames.Edit.Bar:SetAttribute("numbuttons", #RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current])
Rotacast.Frames.Edit.CurrentSequence:SetText(RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current.."|cff69ccf0/|cffff7d0a"..RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Max)
end
function Rotacast.Functions.ChangeSpec()
if (Rotacast.Data.CurrentSpec ~= GetSpecializationInfo(GetSpecialization())) then
Rotacast.Data.CurrentSpec = GetSpecializationInfo(GetSpecialization())
for X = 1, 100 do
Rotacast.Frames.Edit.Button[X]:Hide()
Rotacast.Frames.Edit.Button[X].Border:Hide()
end
Rotacast.Frames.CastButton:SetAttribute("nextcast", nil)
if Rotacast.Frames.CastButton.cooldown:IsVisible() then CooldownFrame_Set(Rotacast.Frames.CastButton.cooldown, _, _, false); end
Rotacast.Functions.LoadButtons()
end
end
function Rotacast.Functions.CreateSequence()
table.insert(RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons, {})
RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Max = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Max + 1
RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Max
for X = 1, 100 do
Rotacast.Frames.Edit.Button[X]:Hide()
Rotacast.Frames.Edit.Button[X].Border:Hide()
end
Rotacast.Frames.CastButton:SetAttribute("nextcast", nil)
if Rotacast.Frames.CastButton.cooldown:IsVisible() then CooldownFrame_Set(Rotacast.Frames.CastButton.cooldown, _, _, false); end
Rotacast.Functions.LoadButtons()
end
function Rotacast.Functions.DeleteSequence()
table.remove(RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons, RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current)
local Empty = false
RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Max = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Max - 1
if (RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Max <= 0) then RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Max = 1; Empty = true; end
RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current - 1
if (RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current <= 0) then RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Max; end
if Empty then table.insert(RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons, {}); end
for X = 1, 100 do
Rotacast.Frames.Edit.Button[X]:Hide()
Rotacast.Frames.Edit.Button[X].Border:Hide()
end
Rotacast.Frames.CastButton:SetAttribute("nextcast", nil)
if Rotacast.Frames.CastButton.cooldown:IsVisible() then CooldownFrame_Set(Rotacast.Frames.CastButton.cooldown, _, _, false); end
Rotacast.Functions.LoadButtons()
end
Rotacast.Frames.Event = CreateFrame("Frame")
Rotacast.Frames.Event:RegisterEvent("ADDON_LOADED")
Rotacast.Frames.Event:RegisterEvent("PLAYER_REGEN_DISABLED")
Rotacast.Frames.Event:RegisterEvent("PLAYER_REGEN_ENABLED")
Rotacast.Frames.Event:RegisterEvent("PLAYER_TARGET_CHANGED")
Rotacast.Frames.Event:RegisterEvent("SPELL_UPDATE_COOLDOWN")
Rotacast.Frames.Event:RegisterEvent("PLAYER_TALENT_UPDATE")
Rotacast.Frames.Event:RegisterEvent("UPDATE_MACROS")
Rotacast.Frames.Event:RegisterEvent("PLAYER_SPECIALIZATION_CHANGED")
Rotacast.Frames.Event:RegisterEvent("PLAYER_LOGIN")
Rotacast.Frames.Event:RegisterEvent("PLAYER_ENTERING_WORLD")
function Rotacast.Frames.Event:OnEvent(Event, Self, ...)
if (Event == "ADDON_LOADED" and Self == "Rotacast") then
Rotacast.Functions.CreateData(Self)
Rotacast.Functions.CreateFrames()
print(" ")
print("|cffffe00a".."(".."|cffff7d0a"..Rotacast.Data.Title, "v"..Rotacast.Data.Version, "|cff69ccf0".."Loaded".."|cffffe00a"..")")
print(" ")
Rotacast.Functions.Generic("ADDON_ACTION_BLOCKED", GetFramesRegisteredForEvent("ADDON_ACTION_BLOCKED"))
Rotacast.Functions.Generic("ADDON_ACTION_FORBIDDEN", GetFramesRegisteredForEvent("ADDON_ACTION_FORBIDDEN"))
end
if (Event == "PLAYER_LOGIN") then
Rotacast.Frames.Event:UnregisterEvent("PLAYER_LOGIN")
Rotacast.Functions.SpecData()
Rotacast.Functions.LoadButtons()
if RotacastPerDB.Version then
if (RotacastPerDB.Version == 1.5) then RotacastPerDB.Version = 1.6; end
end
end
if (Event == "PLAYER_REGEN_DISABLED") then
if Rotacast.Frames.Options:IsVisible() then Rotacast.Frames.Options:Hide(); end
if Rotacast.Frames.GuideDisplay:IsVisible() then Rotacast.Frames.GuideDisplay:Hide(); end
if RotacastPerDB.SequenceOptions.Enter then
local NextCast = Rotacast.Frames.CastButton:GetAttribute("nextcast")
if not NextCast then return; end
Rotacast.Frames.CastButton:SetAttribute("oldcast", NextCast)
Rotacast.Frames.CastButton:SetAttribute("nextcast", 1)
Rotacast.Frames.CastButton:SetAttribute("castoption", "set")
end
if RotacastPerDB.SequenceOptions.Default then
RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current = 1
for X = 1, 100 do
Rotacast.Frames.Edit.Button[X]:Hide()
Rotacast.Frames.Edit.Button[X].Border:Hide()
end
Rotacast.Frames.CastButton:SetAttribute("nextcast", nil)
if Rotacast.Frames.CastButton.cooldown:IsVisible() then CooldownFrame_Set(Rotacast.Frames.CastButton.cooldown, _, _, false); end
Rotacast.Functions.LoadButtons()
end

end
if (Event == "PLAYER_REGEN_ENABLED") then
if RotacastPerDB.SequenceOptions.Leave then
local NextCast = Rotacast.Frames.CastButton:GetAttribute("nextcast")
if not NextCast then return; end
Rotacast.Frames.CastButton:SetAttribute("oldcast", NextCast)
Rotacast.Frames.CastButton:SetAttribute("nextcast", 1)
Rotacast.Frames.CastButton:SetAttribute("castoption", "set")
end
end
if (Event == "PLAYER_TARGET_CHANGED") then
if RotacastPerDB.SequenceOptions.Switch then
if (RotacastPerDB.SequenceOptions.Combat and not InCombatLockdown()) then return; end
local Reset = true
if not UnitName("target") then Reset = false; end
if not (UnitCanAttack("player", "target") or UnitCanAssist("player", "target")) then Reset = false; end
if UnitCanAttack("player", "target") then if UnitIsDead("target") then Reset = false; end; end
if Reset then CooldownFrame_Set(Rotacast.Frames.GenericFrame, GetTime(), 10, true); end
end
end
if (Event == "SPELL_UPDATE_COOLDOWN") then
if not Rotacast.Data.CurrentSpec then return; end
if (#RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current] ~= 0) then Rotacast.Functions.UpdateCooldown(); end
end
if (Event == "PLAYER_TALENT_UPDATE") then
if not Rotacast.Data.CurrentSpec then return; end
if (Rotacast.Data.CurrentSpec ~= GetSpecializationInfo(GetSpecialization())) then return; end
if (#RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current] > 0) then Rotacast.Functions.UpdateIconsTalent(); end
if Rotacast.Frames.CastButton then Rotacast.Functions.SetSpells(); end
end
if not RotacastPerDB.Version then
if (Event == "UPDATE_MACROS") then
Rotacast.Functions.DBUpdateMacros()
RotacastPerDB.Version = 1.4
Rotacast.Frames.Event:UnregisterEvent("UPDATE_MACROS")
end
end
if (Event == "PLAYER_SPECIALIZATION_CHANGED") then
Rotacast.Functions.ChangeSpec()
end
end
Rotacast.Frames.Event:SetScript("OnEvent", Rotacast.Frames.Event.OnEvent)




